angular.module('PostAutoSave',[])
.controller('PostCtrl', ['$scope', 'autoSave', function($scope, autoSave) {

  if( ! angular.isDefined(Storage))
    return;

  // Початкове збереження, якщо користувач перейшов в "розширену відповідь"
  autoSave();
  
  // Автозбереження при введенні тексту
  $('textarea[name=req_message]').on('keyup', autoSave);
  
  if(localStorage.getItem("autosave"))
  {
    // Витягування даних з локальної пам'яті з ключем "autosave"
    var auto_save_data = angular.fromJson(localStorage.getItem("autosave"));
    
    $('textarea[name=req_message]').val(auto_save_data.body);
  }
  
  $scope.before_submit = function()
  {
    localStorage.removeItem("autosave");
  }
}])

.factory('autoSave', ['$timeout', function($timeout) {
  var timer;
  return function()
  {
    var auto_save_callback = function()
    {
      if($('textarea[name=req_message]').val())
      {
        // Дані які будуть зберігатись;
        // припускається, що поле вводу має ім'я body
        var post = {
          "timestemp" : $.now(),
          "body": $('textarea[name=req_message]').val()
        }

        // Збереження даних з ключем "autosave"
        localStorage.setItem
        (
          "autosave"
          ,angular.toJson(post)
        );
      }
    }
    
    if(angular.isDefined(timer))
      $timeout.cancel(timer);
    
    timer = $timeout(auto_save_callback, 2000);
  }
}])

.factory('stateAutoSave', function() {
  return {
    status: null,
    message: null,
    success: function(msg) {
        this.status = 'success';
        this.message = msg;
    },
    error: function(msg) {
        this.status = 'error';
        this.message = msg;
    },
    clear: function() {
        this.status = null;
        this.message = null;
    }
  }
})

.directive('cstAutosaveInfo', function() {
  return {
    restrict: 'E',
    controller:
    [
      '$scope',
      'stateAutoSave',
      function
      (
        $scope,
        stateAutoSave
      ){
        if( ! angular.isDefined(Storage))
          return;
        
        $scope.show = false;
        $scope.stateAutoSave = stateAutoSave;

        $scope.$watch('api.status', toggledisplay);
        $scope.$watch('api.message', toggledisplay);

        if(localStorage.getItem("autosave"))
        {
          $scope.stateAutoSave.success(true);
          $scope.post = angular.fromJson(localStorage.getItem("autosave"));
        }

        $scope.autosave_info = function(success, $event)
        {
          $scope.show = false;
          if(success)
          {
            localStorage.removeItem("autosave");
            $('textarea[name=req_message]').val('');
          }

          $scope.stateAutoSave.clear();
          $event.preventDefault();
        };

        function toggledisplay()
        {
          $scope.show = !!($scope.stateAutoSave.status && $scope.stateAutoSave.message);               
        }
    }],
    template: '<div ' +
                'ng-show="show"'+
                'class="auto-save-info"'+
                '>Це автозбережена версія документа (з вашого поточного браузера) від <b>{{post.timestemp | date:"dd.MM.yyyy, HH:mm:ss"}}</b>,' +
              ' Видалити її?' +
              ' | <a href="#" ng-click="autosave_info(1, $event)">Так</a>' +
              ' | <a href="#" ng-click="autosave_info(0, $event)">Ні</a>' +
              '</div>'
  };
})

;
